SPOJ VECTAR1 数学

来源:互联网 发布:践行五大发展理念 知乎 编辑:程序博客网 时间:2024/06/15 02:32

Matrices with XOR property

no tags 

 

Imagine A is a NxM matrix with two basic properties
1) Each element in the matrix is distinct and lies in the range of 1<=A[i][j]<=(N*M)
2) For any two cells of the matrix, (i1,j1) and (i2,j2), if (i1^j1) > (i2^j2) then A[i1][j1] > A[i2][j2] ,where 
1 ≤ i1,i2 ≤ N
1 ≤ j1,j2 ≤ M.
Given N and M , you have to calculatethe total number of matrices of size N x M which have both the properties
mentioned above.  
Input format:
First line contains T, the number of test cases. 2*T lines follow with N on the first line and M on the second, representing the number of rows and columns respectively.
Output format:
Output the total number of such matrices of size N x M. Since, this answer can be large, output it modulo 10^9+7
Constraints:
1 ≤ N,M,T ≤ 1000
SAMPLE INPUT 
1
2
2
SAMPLE OUTPUT 
4
Explanation
The four possible matrices are:
[1 3] | [2 3] | [1 4] | [2 4]
[4 2] | [4 1] | [3 2] | [3 1]

Imagine A is a NxM matrix with two basic properties


1) Each element in the matrix is distinct and lies in the range of 1<=A[i][j]<=(N*M)

2) For any two cells of the matrix, (i1,j1) and (i2,j2), if (i1^j1) > (i2^j2) then A[i1][j1] > A[i2][j2] ,where 

1 ≤ i1,i2 ≤ N

1 ≤ j1,j2 ≤ M.

^ is Bitwise XOR


Given N and M , you have to calculatethe total number of matrices of size N x M which have both the properties

mentioned above.  


Input format:

First line contains T, the number of test cases. 2*T lines follow with N on the first line and M on the second, representing the number of rows and columns respectively.


Output format:

Output the total number of such matrices of size N x M. Since, this answer can be large, output it modulo 10^9+7


Constraints:

1 ≤ N,M,T ≤ 1000


SAMPLE INPUT 

1

2

2

SAMPLE OUTPUT 

4

Explanation

The four possible matrices are:

[1 3] | [2 3] | [1 4] | [2 4]

[4 2] | [4 1] | [3 2] | [3 1]


题意:找出有多少个排列矩阵  使得下标i1^j1>j2^j2  对应的元素也为a[i1][j1]>a[i2][j2]

排列矩阵是包含1-n*m每个数的矩阵


题解:先考虑一个矩阵n*m的答案,我们只要把i^j相同的位置做排列就行了。因为他们两个的大小没法比,所以可以排列。

因为i^j<=1024  所以记录数字的多少开1024即可。

然后考虑t个n*m

令n<m

我们可以处理出行的前缀和

如果m<=500,那么我们暴力  复杂度是500*500

如果m>500  那么我们取前n行的前缀和,减去前n行  m+1到1000列的数即可  复杂度500*500


#include<iostream>#include<cstdio>#include<cstring>#include<algorithm>#include<deque>using namespace std;typedef long long ll;ll facts[1200],num[1050],sum[1005][1050],vis[1050];int main(){ll i,j,t,n,m;facts[0]=1;for(i=1;i<=1024;i++)facts[i]=facts[i-1]*i%1000000007;for(i=1;i<=1000;i++){for(j=1;j<=1000;j++){num[i^j]++;sum[i][i^j]++;}for(j=0;j<=1024;j++)sum[i][j]+=sum[i-1][j];}scanf("%lld",&t);while(t--){scanf("%lld%lld",&n,&m);if(n>m)swap(n,m);memset(vis,0,sizeof(vis));ll ans=1;if(m<=500){for(i=1;i<=n;i++){for(j=1;j<=m;j++){vis[i^j]++;}}}else{for(i=0;i<=1024;i++)vis[i]=sum[n][i];for(i=1;i<=n;i++){for(j=m+1;j<=1000;j++){vis[i^j]--;}}}for(i=0;i<=1024;i++)ans=ans*facts[vis[i]]%1000000007;printf("%lld\n",ans);}return 0;}


0 0
原创粉丝点击